(** File generated by coq-of-ocaml *)
Require Import CoqOfOCaml.CoqOfOCaml.
Require Import CoqOfOCaml.Settings.

Require Import TezosOfOCaml.Proto_alpha.Environment.
Require TezosOfOCaml.Proto_alpha.Tez_repr.
Require TezosOfOCaml.Proto_alpha.Tx_rollup_commitment_repr.
Require TezosOfOCaml.Proto_alpha.Tx_rollup_level_repr.
Require TezosOfOCaml.Proto_alpha.Tx_rollup_repr.

Module Submit_batch_burn_excedeed.
  Record record : Set := Build {
    burn : Tez_repr.t;
    limit : Tez_repr.t }.
  Definition with_burn burn (r : record) :=
    Build burn r.(limit).
  Definition with_limit limit (r : record) :=
    Build r.(burn) limit.
End Submit_batch_burn_excedeed.
Definition Submit_batch_burn_excedeed := Submit_batch_burn_excedeed.record.

Module Commitment_too_early.
  Record record : Set := Build {
    provided : Tx_rollup_level_repr.t;
    expected : Tx_rollup_level_repr.t }.
  Definition with_provided provided (r : record) :=
    Build provided r.(expected).
  Definition with_expected expected (r : record) :=
    Build r.(provided) expected.
End Commitment_too_early.
Definition Commitment_too_early := Commitment_too_early.record.

Module Wrong_predecessor_hash.
  Record record : Set := Build {
    provided : option Tx_rollup_commitment_repr.Commitment_hash.t;
    expected : option Tx_rollup_commitment_repr.Commitment_hash.t }.
  Definition with_provided provided (r : record) :=
    Build provided r.(expected).
  Definition with_expected expected (r : record) :=
    Build r.(provided) expected.
End Wrong_predecessor_hash.
Definition Wrong_predecessor_hash := Wrong_predecessor_hash.record.

Module Wrong_message_position.
  Record record : Set := Build {
    level : Tx_rollup_level_repr.t;
    position : int;
    length : int }.
  Definition with_level level (r : record) :=
    Build level r.(position) r.(length).
  Definition with_position position (r : record) :=
    Build r.(level) position r.(length).
  Definition with_length length (r : record) :=
    Build r.(level) r.(position) length.
End Wrong_message_position.
Definition Wrong_message_position := Wrong_message_position.record.

(** Init function; without side-effects in Coq *)
Definition init_module_repr : unit :=
  let '_ :=
    Error_monad.register_error_kind Error_monad.Temporary
      "operation.tx_rollup_submit_batch_burn_excedeed"
      "Submit batch excedeed burn limit"
      "The submit batch would exceed the burn limit, we withdraw the submit."
      (Some
        (fun (ppf : Format.formatter) =>
          fun (function_parameter : Tez_repr.t * Tez_repr.t) =>
            let '(burn, limit) := function_parameter in
            Format.fprintf ppf
              (CamlinternalFormatBasics.Format
                (CamlinternalFormatBasics.String_literal
                  "Cannot submit the batch of L2 operations as the cost ("
                  (CamlinternalFormatBasics.Alpha
                    (CamlinternalFormatBasics.String_literal
                      ") would exceed the burn limit ("
                      (CamlinternalFormatBasics.Alpha
                        (CamlinternalFormatBasics.Char_literal ")" % char
                          CamlinternalFormatBasics.End_of_format)))))
                "Cannot submit the batch of L2 operations as the cost (%a) would exceed the burn limit (%a)")
              Tez_repr.pp burn Tez_repr.pp limit))
      (Data_encoding.obj2 (Data_encoding.req None None "burn" Tez_repr.encoding)
        (Data_encoding.req None None "limit" Tez_repr.encoding))
      (fun (function_parameter : Error_monad._error) =>
        match function_parameter with
        | Build_extensible tag _ payload =>
          if String.eqb tag "Submit_batch_burn_excedeed" then
            let '{|
              Submit_batch_burn_excedeed.burn := burn;
                Submit_batch_burn_excedeed.limit := limit
                |} := cast Submit_batch_burn_excedeed payload in
            Some (burn, limit)
          else None
        end)
      (fun (function_parameter : Tez_repr.t * Tez_repr.t) =>
        let '(burn, limit) := function_parameter in
        Build_extensible "Submit_batch_burn_excedeed" Submit_batch_burn_excedeed
          {| Submit_batch_burn_excedeed.burn := burn;
            Submit_batch_burn_excedeed.limit := limit |}) in
  let '_ :=
    Error_monad.register_error_kind Error_monad.Temporary
      "tx_rollup_inbox_does_not_exist" "Missing transaction rollup inbox"
      "The transaction rollup does not have an inbox at this level"
      (Some
        (fun (ppf : Format.formatter) =>
          fun (function_parameter :
            Tx_rollup_repr.t * Tx_rollup_level_repr.level) =>
            let '(addr, level) := function_parameter in
            Format.fprintf ppf
              (CamlinternalFormatBasics.Format
                (CamlinternalFormatBasics.String_literal "Transaction rollup "
                  (CamlinternalFormatBasics.Alpha
                    (CamlinternalFormatBasics.String_literal
                      " does not have an inbox at level "
                      (CamlinternalFormatBasics.Alpha
                        CamlinternalFormatBasics.End_of_format))))
                "Transaction rollup %a does not have an inbox at level %a")
              Tx_rollup_repr.pp addr Tx_rollup_level_repr.pp level))
      (Data_encoding.obj2
        (Data_encoding.req None None "tx_rollup_address" Tx_rollup_repr.encoding)
        (Data_encoding.req None None "raw_level" Tx_rollup_level_repr.encoding))
      (fun (function_parameter : Error_monad._error) =>
        match function_parameter with
        | Build_extensible tag _ payload =>
          if String.eqb tag "Inbox_does_not_exist" then
            let '(rollup, level) :=
              cast (Tx_rollup_repr.t * Tx_rollup_level_repr.t) payload in
            Some (rollup, level)
          else None
        end)
      (fun (function_parameter : Tx_rollup_repr.t * Tx_rollup_level_repr.level)
        =>
        let '(rollup, level) := function_parameter in
        Build_extensible "Inbox_does_not_exist"
          (Tx_rollup_repr.t * Tx_rollup_level_repr.level) (rollup, level)) in
  let '_ :=
    Error_monad.register_error_kind Error_monad.Temporary
      "tx_rollup_inbox_size_would_exceed_limit"
      "Transaction rollup inbox\226\128\153s size would exceed the limit"
      "Transaction rollup inbox\226\128\153s size in bytes would exceed the limit"
      (Some
        (fun (ppf : Format.formatter) =>
          fun (addr : Tx_rollup_repr.t) =>
            Format.fprintf ppf
              (CamlinternalFormatBasics.Format
                (CamlinternalFormatBasics.String_literal
                  "Adding the submitted message would make the inbox of "
                  (CamlinternalFormatBasics.Alpha
                    (CamlinternalFormatBasics.String_literal
                      " exceed the authorized size in bytes at this level"
                      CamlinternalFormatBasics.End_of_format)))
                "Adding the submitted message would make the inbox of %a exceed the authorized size in bytes at this level")
              Tx_rollup_repr.pp addr))
      (Data_encoding.obj1
        (Data_encoding.req None None "tx_rollup_address" Tx_rollup_repr.encoding))
      (fun (function_parameter : Error_monad._error) =>
        match function_parameter with
        | Build_extensible tag _ payload =>
          if String.eqb tag "Inbox_size_would_exceed_limit" then
            let 'rollup := cast Tx_rollup_repr.t payload in
            Some rollup
          else None
        end)
      (fun (rollup : Tx_rollup_repr.t) =>
        Build_extensible "Inbox_size_would_exceed_limit" Tx_rollup_repr.t rollup)
    in
  let '_ :=
    Error_monad.register_error_kind Error_monad.Temporary
      "tx_rollup_inbox_count_would_exceed_limit"
      "Transaction rollup inbox\226\128\153s message count would exceed the limit"
      "Transaction rollup inbox\226\128\153s message count would exceed the limit"
      (Some
        (fun (ppf : Format.formatter) =>
          fun (addr : Tx_rollup_repr.t) =>
            Format.fprintf ppf
              (CamlinternalFormatBasics.Format
                (CamlinternalFormatBasics.String_literal
                  "Adding the submitted message would make the inbox of "
                  (CamlinternalFormatBasics.Alpha
                    (CamlinternalFormatBasics.String_literal
                      " exceed the authorized message count at this level"
                      CamlinternalFormatBasics.End_of_format)))
                "Adding the submitted message would make the inbox of %a exceed the authorized message count at this level")
              Tx_rollup_repr.pp addr))
      (Data_encoding.obj1
        (Data_encoding.req None None "tx_rollup_address" Tx_rollup_repr.encoding))
      (fun (function_parameter : Error_monad._error) =>
        match function_parameter with
        | Build_extensible tag _ payload =>
          if String.eqb tag "Inbox_count_would_exceed_limit" then
            let 'rollup := cast Tx_rollup_repr.t payload in
            Some rollup
          else None
        end)
      (fun (rollup : Tx_rollup_repr.t) =>
        Build_extensible "Inbox_count_would_exceed_limit" Tx_rollup_repr.t
          rollup) in
  let '_ :=
    Error_monad.register_error_kind Error_monad.Temporary
      "tx_rollup_no_uncommitted_inbox"
      "There is no inbox awaiting a commitment."
      "There is no inbox awaiting a commitment." None Data_encoding.empty
      (fun (function_parameter : Error_monad._error) =>
        match function_parameter with
        | Build_extensible tag _ payload =>
          if String.eqb tag "No_uncommitted_inbox" then
            Some tt
          else None
        end)
      (fun (function_parameter : unit) =>
        let '_ := function_parameter in
        Build_extensible "No_uncommitted_inbox" unit tt) in
  let '_ :=
    Error_monad.register_error_kind Error_monad.Temporary
      "tx_rollup_invalid_proof" "The proof submitted for a rejection is invalid"
      "The proof submitted for a rejection is invalid" None Data_encoding.empty
      (fun (function_parameter : Error_monad._error) =>
        match function_parameter with
        | Build_extensible tag _ payload =>
          if String.eqb tag "Invalid_proof" then
            Some tt
          else None
        end)
      (fun (function_parameter : unit) =>
        let '_ := function_parameter in
        Build_extensible "Invalid_proof" unit tt) in
  let '_ :=
    Error_monad.register_error_kind Error_monad.Temporary
      "tx_rollup_message_size_exceeds_limit"
      "A message submitted to a transaction rollup inbox exceeds limit"
      "A message submitted to a transaction rollup inbox exceeds limit" None
      Data_encoding.empty
      (fun (function_parameter : Error_monad._error) =>
        match function_parameter with
        | Build_extensible tag _ payload =>
          if String.eqb tag "Message_size_exceeds_limit" then
            Some tt
          else None
        end)
      (fun (function_parameter : unit) =>
        let '_ := function_parameter in
        Build_extensible "Message_size_exceeds_limit" unit tt) in
  let '_ :=
    Error_monad.register_error_kind Error_monad.Temporary
      "tx_rollup_too_many_inboxes"
      "Cannot create a new inbox because there are too many already"
      "Cannot create a new inbox because there are too many already" None
      Data_encoding.empty
      (fun (function_parameter : Error_monad._error) =>
        match function_parameter with
        | Build_extensible tag _ payload =>
          if String.eqb tag "Too_many_inboxes" then
            Some tt
          else None
        end)
      (fun (function_parameter : unit) =>
        let '_ := function_parameter in
        Build_extensible "Too_many_inboxes" unit tt) in
  let '_ :=
    Error_monad.register_error_kind Error_monad.Temporary
      "tx_rollup_too_many_finalized_commitments"
      "Too many finalized commitments"
      "Cannot create a new commitment because there are too many finalized commitments"
      None Data_encoding.empty
      (fun (function_parameter : Error_monad._error) =>
        match function_parameter with
        | Build_extensible tag _ payload =>
          if String.eqb tag "Too_many_finalized_commitments" then
            Some tt
          else None
        end)
      (fun (function_parameter : unit) =>
        let '_ := function_parameter in
        Build_extensible "Too_many_finalized_commitments" unit tt) in
  let '_ :=
    Error_monad.register_error_kind Error_monad.Temporary
      "tx_rollup_wrong_batch_count"
      "This commitment has the wrong number of batches"
      "This commitment has a different number of batches than its inbox" None
      Data_encoding.unit_value
      (fun (function_parameter : Error_monad._error) =>
        match function_parameter with
        | Build_extensible tag _ payload =>
          if String.eqb tag "Wrong_batch_count" then
            Some tt
          else None
        end)
      (fun (function_parameter : unit) =>
        let '_ := function_parameter in
        Build_extensible "Wrong_batch_count" unit tt) in
  let '_ :=
    Error_monad.register_error_kind Error_monad.Temporary
      "tx_rollup_commitment_too_early"
      "Cannot submit a commitment for this level yet"
      "It is not possible to submit a commitment for this level just yet." None
      (Data_encoding.obj2
        (Data_encoding.req None None "provided" Tx_rollup_level_repr.encoding)
        (Data_encoding.req None None "expected" Tx_rollup_level_repr.encoding))
      (fun (function_parameter : Error_monad._error) =>
        match function_parameter with
        | Build_extensible tag _ payload =>
          if String.eqb tag "Commitment_too_early" then
            let '{|
              Commitment_too_early.provided := provided;
                Commitment_too_early.expected := expected
                |} := cast Commitment_too_early payload in
            Some (provided, expected)
          else None
        end)
      (fun (function_parameter :
        Tx_rollup_level_repr.level * Tx_rollup_level_repr.level) =>
        let '(provided, expected) := function_parameter in
        Build_extensible "Commitment_too_early" Commitment_too_early
          {| Commitment_too_early.provided := provided;
            Commitment_too_early.expected := expected |}) in
  let '_ :=
    Error_monad.register_error_kind Error_monad.Temporary
      "tx_rollup_level_already_has_commitment"
      "This commitment is for a level that already has a commitment"
      "This commitment is for a level that already has a commitment" None
      (Data_encoding.obj1
        (Data_encoding.req None None "level" Tx_rollup_level_repr.encoding))
      (fun (function_parameter : Error_monad._error) =>
        match function_parameter with
        | Build_extensible tag _ payload =>
          if String.eqb tag "Level_already_has_commitment" then
            let 'level := cast Tx_rollup_level_repr.t payload in
            Some level
          else None
        end)
      (fun (level : Tx_rollup_level_repr.level) =>
        Build_extensible "Level_already_has_commitment"
          Tx_rollup_level_repr.level level) in
  let '_ :=
    Error_monad.register_error_kind Error_monad.Branch "Wrong_inbox_hash"
      "This commitment has the wrong inbox hash"
      "This commitment has a different hash than its inbox" None
      Data_encoding.unit_value
      (fun (function_parameter : Error_monad._error) =>
        match function_parameter with
        | Build_extensible tag _ payload =>
          if String.eqb tag "Wrong_inbox_hash" then
            Some tt
          else None
        end)
      (fun (function_parameter : unit) =>
        let '_ := function_parameter in
        Build_extensible "Wrong_inbox_hash" unit tt) in
  let '_ :=
    Error_monad.register_error_kind Error_monad.Temporary
      "tx_rollup_bond_does_not_exist"
      "This account does not have a bond for this rollup"
      "This account does not have a bond for this rollup" None
      (Data_encoding.obj1
        (Data_encoding.req None None "contract"
          Signature.Public_key_hash.(S.SIGNATURE_PUBLIC_KEY_HASH.encoding)))
      (fun (function_parameter : Error_monad._error) =>
        match function_parameter with
        | Build_extensible tag _ payload =>
          if String.eqb tag "Bond_does_not_exist" then
            let 'contract := cast Signature.public_key_hash payload in
            Some contract
          else None
        end)
      (fun (contract : Signature.public_key_hash) =>
        Build_extensible "Bond_does_not_exist" Signature.public_key_hash
          contract) in
  let '_ :=
    Error_monad.register_error_kind Error_monad.Temporary
      "tx_rollup_bond_in_use"
      "This account's bond is in use for one or more commitments"
      "This account's bond is in use for one or more commitments" None
      (Data_encoding.obj1
        (Data_encoding.req None None "contract"
          Signature.Public_key_hash.(S.SIGNATURE_PUBLIC_KEY_HASH.encoding)))
      (fun (function_parameter : Error_monad._error) =>
        match function_parameter with
        | Build_extensible tag _ payload =>
          if String.eqb tag "Bond_in_use" then
            let 'contract := cast Signature.public_key_hash payload in
            Some contract
          else None
        end)
      (fun (contract : Signature.public_key_hash) =>
        Build_extensible "Bond_in_use" Signature.public_key_hash contract) in
  let '_ :=
    Error_monad.register_error_kind Error_monad.Temporary
      "tx_rollup_no_commitment_to_finalize" "There is no commitment to finalize"
      "There is no commitment to finalize" None Data_encoding.empty
      (fun (function_parameter : Error_monad._error) =>
        match function_parameter with
        | Build_extensible tag _ payload =>
          if String.eqb tag "No_commitment_to_finalize" then
            Some tt
          else None
        end)
      (fun (function_parameter : unit) =>
        let '_ := function_parameter in
        Build_extensible "No_commitment_to_finalize" unit tt) in
  let '_ :=
    Error_monad.register_error_kind Error_monad.Temporary
      "tx_rollup_no_commitment_to_remove" "There is no commitment to remove"
      "There is no commitment to remove" None Data_encoding.empty
      (fun (function_parameter : Error_monad._error) =>
        match function_parameter with
        | Build_extensible tag _ payload =>
          if String.eqb tag "No_commitment_to_remove" then
            Some tt
          else None
        end)
      (fun (function_parameter : unit) =>
        let '_ := function_parameter in
        Build_extensible "No_commitment_to_remove" unit tt) in
  let '_ :=
    Error_monad.register_error_kind Error_monad.Temporary
      "tx_rollup_invalid_rejection_level_argument"
      "Received a rejection with an incorrect level argument"
      "Received a rejection with an incorrect level argument" None
      Data_encoding.empty
      (fun (function_parameter : Error_monad._error) =>
        match function_parameter with
        | Build_extensible tag _ payload =>
          if String.eqb tag "Invalid_rejection_level_argument" then
            Some tt
          else None
        end)
      (fun (function_parameter : unit) =>
        let '_ := function_parameter in
        Build_extensible "Invalid_rejection_level_argument" unit tt) in
  let '_ :=
    Error_monad.register_error_kind Error_monad.Temporary
      "tx_rollup_commitment_does_not_exist"
      "There is no commitment at the requested level"
      "There is no commitment at the requested level" None
      (Data_encoding.obj1
        (Data_encoding.req None None "provided" Tx_rollup_level_repr.encoding))
      (fun (function_parameter : Error_monad._error) =>
        match function_parameter with
        | Build_extensible tag _ payload =>
          if String.eqb tag "Commitment_does_not_exist" then
            let 'l_value := cast Tx_rollup_level_repr.t payload in
            Some l_value
          else None
        end)
      (fun (l_value : Tx_rollup_level_repr.level) =>
        Build_extensible "Commitment_does_not_exist" Tx_rollup_level_repr.level
          l_value) in
  let '_ :=
    Error_monad.register_error_kind Error_monad.Temporary
      "tx_rollup_wrong_predecessor_hash"
      "The commitment refers to a commitment that is not in the context"
      "The commitment refers to a commitment that is not in the context" None
      (Data_encoding.obj2
        (Data_encoding.req None None "provided"
          (Data_encoding.option_value
            Tx_rollup_commitment_repr.Commitment_hash.encoding))
        (Data_encoding.req None None "expected"
          (Data_encoding.option_value
            Tx_rollup_commitment_repr.Commitment_hash.encoding)))
      (fun (function_parameter : Error_monad._error) =>
        match function_parameter with
        | Build_extensible tag _ payload =>
          if String.eqb tag "Wrong_predecessor_hash" then
            let '{|
              Wrong_predecessor_hash.provided := provided;
                Wrong_predecessor_hash.expected := expected
                |} := cast Wrong_predecessor_hash payload in
            Some (provided, expected)
          else None
        end)
      (fun (function_parameter :
        option Tx_rollup_commitment_repr.Commitment_hash.t *
          option Tx_rollup_commitment_repr.Commitment_hash.t) =>
        let '(provided, expected) := function_parameter in
        Build_extensible "Wrong_predecessor_hash" Wrong_predecessor_hash
          {| Wrong_predecessor_hash.provided := provided;
            Wrong_predecessor_hash.expected := expected |}) in
  let '_ :=
    Error_monad.register_error_kind Error_monad.Permanent
      "tx_rollup_already_exists" "Transaction rollup was already created"
      "The protocol tried to originate the same transaction rollup twice"
      (Some
        (fun (ppf : Format.formatter) =>
          fun (addr : Tx_rollup_repr.t) =>
            Format.fprintf ppf
              (CamlinternalFormatBasics.Format
                (CamlinternalFormatBasics.String_literal "Transaction rollup "
                  (CamlinternalFormatBasics.Alpha
                    (CamlinternalFormatBasics.String_literal
                      " is already used for an existing transaction rollup. This should not happen, and indicates there is a bug in the protocol. If you can, please report this bug (https://gitlab.com/tezos/tezos/-/issues.)"
                      CamlinternalFormatBasics.End_of_format)))
                "Transaction rollup %a is already used for an existing transaction rollup. This should not happen, and indicates there is a bug in the protocol. If you can, please report this bug (https://gitlab.com/tezos/tezos/-/issues.)")
              Tx_rollup_repr.pp addr))
      (Data_encoding.obj1
        (Data_encoding.req None None "rollup_address" Tx_rollup_repr.encoding))
      (fun (function_parameter : Error_monad._error) =>
        match function_parameter with
        | Build_extensible tag _ payload =>
          if String.eqb tag "Tx_rollup_already_exists" then
            let 'rollup := cast Tx_rollup_repr.t payload in
            Some rollup
          else None
        end)
      (fun (rollup : Tx_rollup_repr.t) =>
        Build_extensible "Tx_rollup_already_exists" Tx_rollup_repr.t rollup) in
  let '_ :=
    Error_monad.register_error_kind Error_monad.Temporary
      "tx_rollup_does_not_exist" "Transaction rollup does not exist"
      "An invalid transaction rollup address was submitted"
      (Some
        (fun (ppf : Format.formatter) =>
          fun (addr : Tx_rollup_repr.t) =>
            Format.fprintf ppf
              (CamlinternalFormatBasics.Format
                (CamlinternalFormatBasics.String_literal
                  "Invalid transaction rollup address "
                  (CamlinternalFormatBasics.Alpha
                    CamlinternalFormatBasics.End_of_format))
                "Invalid transaction rollup address %a") Tx_rollup_repr.pp addr))
      (Data_encoding.obj1
        (Data_encoding.req None None "rollup_address" Tx_rollup_repr.encoding))
      (fun (function_parameter : Error_monad._error) =>
        match function_parameter with
        | Build_extensible tag _ payload =>
          if String.eqb tag "Tx_rollup_does_not_exist" then
            let 'rollup := cast Tx_rollup_repr.t payload in
            Some rollup
          else None
        end)
      (fun (rollup : Tx_rollup_repr.t) =>
        Build_extensible "Tx_rollup_does_not_exist" Tx_rollup_repr.t rollup) in
  let '_ :=
    Error_monad.register_error_kind Error_monad.Permanent
      "tx_rollup_internal_error" "An internal error occurred"
      "An internal error occurred" None
      (Data_encoding.obj1
        (Data_encoding.req None None "description" Data_encoding.string_value))
      (fun (function_parameter : Error_monad._error) =>
        match function_parameter with
        | Build_extensible tag _ payload =>
          if String.eqb tag "Internal_error" then
            let 'str := cast string payload in
            Some str
          else None
        end)
      (fun (str : string) => Build_extensible "Internal_error" string str) in
  let '_ :=
    Error_monad.register_error_kind Error_monad.Branch
      "tx_rollup_wrong_message_position" "Wrong message index in rejection"
      "The rejection references the {position}^th message of the inbox {l} which contains only {inbox_length} messages"
      None
      (Data_encoding.obj3
        (Data_encoding.req None None "level" Tx_rollup_level_repr.encoding)
        (Data_encoding.req None None "position" Data_encoding.int31)
        (Data_encoding.req None None "length" Data_encoding.int31))
      (fun (function_parameter : Error_monad._error) =>
        match function_parameter with
        | Build_extensible tag _ payload =>
          if String.eqb tag "Wrong_message_position" then
            let '{|
              Wrong_message_position.level := level;
                Wrong_message_position.position := position;
                Wrong_message_position.length := length
                |} := cast Wrong_message_position payload in
            Some (level, position, length)
          else None
        end)
      (fun (function_parameter : Tx_rollup_level_repr.level * int * int) =>
        let '(level, position, length) := function_parameter in
        Build_extensible "Wrong_message_position" Wrong_message_position
          {| Wrong_message_position.level := level;
            Wrong_message_position.position := position;
            Wrong_message_position.length := length |}) in
  Error_monad.register_error_kind Error_monad.Branch
    "tx_rollup_wrong_message_hash" "Wrong message hash in rejection."
    "This rejection has sent a message with a hash that doesn't match the stored one"
    None Data_encoding.unit_value
    (fun (function_parameter : Error_monad._error) =>
      match function_parameter with
      | Build_extensible tag _ payload =>
        if String.eqb tag "Wrong_message_hash" then
          Some tt
        else None
      end)
    (fun (function_parameter : unit) =>
      let '_ := function_parameter in
      Build_extensible "Wrong_message_hash" unit tt).
